<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>Image - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="Image.html">Image</a><ul class='members'><li data-type='member' style='display: none;'><a href="Image.html#channels">channels</a></li><li data-type='member' style='display: none;'><a href="Image.html#parameters">parameters</a></li></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Image.html#set">set</a></li></ul></li><li style="display:none"><a href="aidecv-Setter.html">Setter</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="aidecv-Setter.html#set">set</a></li><li data-type='method' style='display: none;'><a href="aidecv-Setter.html#.getSetters">getSetters</a></li></ul></li><li style="display:none"><a href="aidecv-Similarity.html">Similarity</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="aidecv-Similarity.html#set">set</a></li><li data-type='method' style='display: none;'><a href="aidecv-Similarity.html#.getSimilarities">getSimilarities</a></li></ul></li><li><a href="commands.html">commands</a><ul class='members'></ul></li><li><a href="aidecv.html">aidecv</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="aidecv.html#.mat2mat">mat2mat</a></li><li data-type='method' style='display: none;'><a href="aidecv.html#.mat2json">mat2json</a></li><li data-type='method' style='display: none;'><a href="aidecv.html#.mat2txt">mat2txt</a></li><li data-type='method' style='display: none;'><a href="aidecv.html#.bgr2bin">bgr2bin</a></li></ul></li><li style="display:none"><a href="aidecv-opencvwindow.html">opencvwindow</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="aidecv-opencvwindow.html#.show">show</a></li><li data-type='method' style='display: none;'><a href="aidecv-opencvwindow.html#.waitUntilWindowsClosed">waitUntilWindowsClosed</a></li></ul></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">Image</h1>
    

    




<section>

<header>
    
        <h2>
        
            Image
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="Image"><span class="type-signature"></span>new Image<span class="signature">(command<span class="signature-attributes">opt</span>, source<span class="signature-attributes">opt</span>)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Implements image processing, at a symbolic level, in this context.</p>
<ul>
<li>An Image is defined by a:
<ul>
<li>A set of channels storing image computations.</li>
<li>A set of parameters extracted from image computations.</li>
</ul>
</li>
<li>The implementation is based on <a href="https://docs.opencv.org/4.0.0">opencv</a>.</li>
<li>Available commands are defined as <a href="parameters.html">image setters</a>.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>command</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>copy</code>
                
                </td>
            

            <td class="description last"><p>The command input parameters.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>source</code></td>
            

            <td class="type">
            
                
<span class="param-type"><a href="Image.html">Image</a></span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>An optional source image, if needed.</p></td>
        </tr>

    
    </tbody>
</table>



















        
        </div>
    

    

    

    
    
    

     

    

    
        <h3 class="subsection-title">Members</h3>

        
            













        
            
<h4 class="name" id="channels"><span class="type-signature"></span>channels<span class="type-signature"> :Map</span></h4>





<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Low-level access to the Image internal elements</p>
<ul>
<li>The <code>std::map &lt; std::string, cv::Mat &gt; channels</code> map of opencv <code>cv::Mat</code> is a read/write data struture member.</li>
<li>Each input/output channel is described in the corresponding setter description.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>





<div class="description usertext">
    <p>Low-level access to the Image internal elements</p>
<ul>
<li>The <code>std::map &lt; std::string, cv::Mat &gt; channels</code> map of opencv <code>cv::Mat</code> is a read/write data struture member.</li>
<li>Each input/output channel is described in the corresponding setter description.</li>
</ul>
</div>



    <h5 class="h5-types">Type:</h5>
    <ul>
        <li>
            
<span class="param-type">Map</span>



        </li>
    </ul>






        
            
<h4 class="name" id="parameters"><span class="type-signature"></span>parameters<span class="type-signature"> :Value</span></h4>





<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Read/write access to the image parameters.</p>
<ul>
<li>By contract each setter modifies the <code>parameters[&quot;setter-name&quot;]</code> data structure.</li>
<li>The <code>wjson::Value parameters</code> data structure contains all information on image processing and obtained values.</li>
<li>Each input/output parameters are described in the corresponding setter description.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>





<div class="description usertext">
    <p>Read/write access to the image parameters.</p>
<ul>
<li>By contract each setter modifies the <code>parameters[&quot;setter-name&quot;]</code> data structure.</li>
<li>The <code>wjson::Value parameters</code> data structure contains all information on image processing and obtained values.</li>
<li>Each input/output parameters are described in the corresponding setter description.</li>
</ul>
</div>



    <h5 class="h5-types">Type:</h5>
    <ul>
        <li>
            
<span class="param-type">Value</span>



        </li>
    </ul>






        
    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id="set"><span class="type-signature"></span>set<span class="signature">(command, source<span class="signature-attributes">opt</span>)</span><span class="type-signature"> &rarr; {<a href="Image.html">Image</a>}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Sets channels and parameters of this image.</p>
<ul>
<li>Available commands are defined as <a href="commands.html">image setters</a>;</li>
<li>Other ``setter´´ mechanisms can be implemented via the <a href="https://gitlab.inria.fr/line/aide-group/aidecv/-/blob/master/src/Setter.hpp">Setter</a> hook.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>command</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            

            <td class="description last"><p>The command input command.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>source</code></td>
            

            <td class="type">
            
                
<span class="param-type"><a href="Image.html">Image</a></span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            

            <td class="description last"><p>An optional source image, if needed.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>This image, allowing construct of the form <code>image.set(&quot;{...&quot;).set(&quot;{...&quot;)</code>.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type"><a href="Image.html">Image</a></span>



    </dd>
</dl>

    



        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>